package io.controller;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import io.annotation.Login;
import io.common.constant.Constant;
import io.common.page.PageData;
import io.common.utils.Result;
import io.common.validator.AssertUtils;
import io.common.validator.ValidatorUtils;
import io.common.validator.group.AddGroup;
import io.common.validator.group.DefaultGroup;
import io.common.validator.group.UpdateGroup;
import io.modules.item.dao.ApplicationsDao;
import io.modules.item.dao.CertificatesDao;
import io.modules.item.dto.ApplicationsDTO;
import io.modules.item.dto.CertificatesDTO;
import io.modules.item.dto.UserDTO;
import io.modules.item.entity.Applications;
import io.modules.item.entity.CertificatesEntity;
import io.modules.item.service.ApplicationsService;
import io.modules.item.service.CertificatesService;
import io.modules.item.service.FrontUserService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Parameters;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 申请表
 */
@RestController
@RequestMapping("/api/applications")
@Tag(name="证书表")
@CrossOrigin
public class ApplicationsController {
    @Autowired
    private ApplicationsService applicationsService;
    @Autowired
    private CertificatesService certificatesService;
    @Autowired
    private FrontUserService userService;

    @Autowired
    private ApplicationsDao applicationsDao;

    @Value("${upload.url}")
    private  String uploadUrl;
    @Login
    @GetMapping("page")
    @Operation(summary = "分页")
    @Parameters({
            @Parameter(name = Constant.PAGE, description = "当前页码，从1开始", in = ParameterIn.QUERY, required = true, ref="int") ,
            @Parameter(name = Constant.LIMIT, description = "每页显示记录数", in = ParameterIn.QUERY,required = true, ref="int") ,
            @Parameter(name = Constant.ORDER_FIELD, description = "排序字段", in = ParameterIn.QUERY, ref="String") ,
            @Parameter(name = Constant.ORDER, description = "排序方式，可选值(asc、desc)", in = ParameterIn.QUERY, ref="String")
    })
    public Result<PageData<ApplicationsDTO>> page(@Parameter(hidden = true) @RequestParam Map<String, Object> params,@Parameter(hidden = true) @RequestAttribute("userId") Long userId){
        params.put("userId",userId);
        PageData<ApplicationsDTO> page = applicationsService.page(params);
        List<ApplicationsDTO> collect = page.getList().stream().map(e -> {

            UserDTO userDTO = userService.get(e.getUserId());
            e.setUser(userDTO);
            CertificatesDTO certificatesDTO = certificatesService.get(e.getCertId());
            if (certificatesDTO != null){
                certificatesDTO.setImg(uploadUrl + certificatesDTO.getImg());
                e.setCertificates(certificatesDTO);
            }
            return e;  // 返回修改后的对象
        }).collect(Collectors.toList());
        page.setList(collect);
        return new Result<PageData<ApplicationsDTO>>().ok(page);
    }


    @Login
    @PostMapping
    @Operation(summary = "保存")
    public Result save(@RequestBody ApplicationsDTO dto,@Parameter(hidden = true) @RequestAttribute("userId") Long userId){
        CertificatesDTO certificatesDTO = certificatesService.get(dto.getCertId());
        if (certificatesDTO.getUserId() == userId){
            return new Result().error("不可以申请自己的证书");
        }


        LambdaQueryWrapper<Applications> lwq = new LambdaQueryWrapper<>();
        lwq.eq(Applications::getUserId,userId);
        lwq.eq(Applications::getCertId,dto.getCertId());
        List<Applications> list = applicationsDao.selectList(lwq);
        if (!list.isEmpty()){
            return new Result().error("不可以重复申请");
        }
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);
        dto.setUserId(userId);
        applicationsService.save(dto);
        return new Result();
    }

    @PutMapping
    @Operation(summary = "修改")
    public Result update(@RequestBody ApplicationsDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);
        applicationsService.update(dto);
        return new Result();
    }

    @DeleteMapping
    @Operation(summary = "删除")
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");
        applicationsService.delete(ids);
        return new Result();
    }

}
